<template>
  <ContentWrapper>
    <div class="content-heading">
      <div>Relação de bancos
        <ol class="breadcrumb breadcrumb px-0 pb-0">
          <li class="breadcrumb-item active">
            <a href="/banks" @click.prevent="$router.push({path:'/banks'})">Bancos</a>
          </li>
        </ol>
      </div>
    </div>
    <!-- LISTAGEM -->
    <div class="card">
      <!-- <div class="card-header">
        <div class="card-title">Relação de bancos</div>
        <div class="text-sm"></div>
      </div>-->
      <div :class="'card-body'+(process.list ? ' whirl duo':'')">
        <Datatable
          v-if="!process.list"
          :options="dtOptions"
          class="table table-striped my-4 h-75 w-100"
          id="datatable"
        >
          <thead>
            <tr>
              <th>#</th>
              <th class="sort-alpha" data-priority="1">Nome</th>
              <th>Número</th>
              <th>Ação</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="bk in banks" :key="bk.bank_id">
              <td>{{bk.bank_id}}</td>
              <td>{{bk.bank_name}}</td>
              <td>{{bk.bank_number}}</td>
              <td>
                <div class="btn-group">
                  <button id="btnEdit" class="btn btn-info btn-sm" type="button" @click="edit(bk)">
                    <em class="fas fa-user-edit" style="padding:5px"></em>
                  </button>
                  <!-- <b-tooltip :target="'btnEdit'" triggers="hover focus" :title="'Editar banco'"/> -->
                  <button
                    id="btnExcluir"
                    class="btn btn-danger btn-sm"
                    type="button"
                    @click="remove(bk)"
                  >
                    <em class="fas fa-user-alt-slash" style="padding:5px"></em>
                  </button>
                  <!-- <b-tooltip
                    :target="'btnExcluir'"
                    triggers="hover focus"
                    :title="'Excluir banco'"
                  />-->
                </div>
              </td>
            </tr>
          </tbody>
        </Datatable>
      </div>
    </div>
  </ContentWrapper>
</template>
<script>
import Datatable from "@/components/Tables/Datatable";
import BankService from "@/domain/bank/BankService";

import Bank from "@/domain/bank/Bank";

import NotificationProvider from "@/provider/NotificationProvider";
import swal from "sweetalert2";

export default {
  name: "bank-list",
  components: {
    Datatable
  },
  created() {
    this.process.list = true;
    this.bankService
      .list(999, 1)
      .then(response => {
        this.banks = response;
        this.process.list = false;
      })
      .catch(err => {
        console.log(JSON.stringify(err));
        this.notificationProvider.error(
          "Falha na comunicação",
          "Falha ao listar os usuários"
        );
        this.process.list = false;
      });
  },
  data() {
    return {
      process: {
        list: false
      },
      bankService: new BankService(),
      banks: [],
      notificationProvider: new NotificationProvider(this.$notify),
      dtOptions: {
        paging: true, // Table pagination
        ordering: true, // Column ordering
        info: true, // Bottom left status text
        responsive: true,
        // Text translation options
        // Note the required keywords between underscores (e.g _MENU_)
        oLanguage: {
          sSearch: '<em class="fa fa-search"></em>',
          sLengthMenu: "_MENU_ registros por página",
          info: "Página _PAGE_ de _PAGES_",
          zeroRecords: "Nada encontrado",
          infoEmpty: "Nenhum registro",
          infoFiltered: "(Filtrado de _MAX_ itens)",
          oPaginate: {
            sNext: '<em class="fa fa-caret-right"></em>',
            sPrevious: '<em class="fa fa-caret-left"></em>'
          }
        },
        // Datatable key setup
        keys: false
      }
    };
  },
  methods: {
    remove(bank) {
      swal({
        title: "Deletar " + bank.bank_name + "?",
        text: "Não será possível recuperar!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#DD6B55",
        confirmButtonText: "Sim, deletar!"
      }).then(result => {
        if (result.value) {
          this.bankService
            .delete(bank.bank_id)
            .then(response => {
              this.banks.forEach((el, index) => {
                if (bank.bank_id == el.bank_id) {
                  this.banks.splice(index, 1);
                }
              });
              this.notificationProvider.success(
                "Deletado",
                "Banco " + bank.bank_name + " deletado com sucesso!"
              );
            })
            .catch(err => {
              if (
                err.response &&
                err.response.data &&
                err.response.data.message &&
                err.response.data.message.indexOf(
                  "Integrity constraint violation"
                )
              ) {
                // erro de vinculo no banco
                this.notificationProvider.error(
                  "Não é possível remover",
                  "Existem registros vinculados a este registro"
                );
              } else {
                console.log(JSON.stringify(err));
                this.notificationProvider.error(
                  "Falha ao remover",
                  "Não foi possível remover este registro"
                );
              }
            });
        }
      });
    },
    edit(bank) {
      this.$router.push({ path: "/bank/" + bank.bank_id });
    }
  }
};
</script>
<style>
.tam {
  background-color: aquamarine;
}
</style>
